#include <errno.h>
#include <stdarg.h>
#include <unistd.h>

#include <sys/xglob.h>

#include <sys/termios.h>
#include <sys/tty.h>
#include <sys/ioctl.h>

#include <sys/dos.h>
#include <sys/iocs.h>



#include "ttywork.h"


extern	struct	tty	*_libc_tty_ptr;
extern  struct  _ttywork *_libc_ttywork_ptr;


extern	char _character_code_flag[256];


int ioctl( int fd , unsigned long request , ... )
{
	va_list ap;

	va_start(ap, request);


#ifdef EBADF_CHECKER
	/* t@Cnh`FbN */
	if (_usedfd (fd) < 0) {
		errno = EBADF;
		return -1;
	}
#endif

	/* TTY ? */
	if( !isatty(fd) ){
		errno = ENOTTY;
		return -1;
	}


	switch( request ){
	case TIOCPKT:
	case TIOCSPGRP:
	case TIOCGPGRP:
		errno = ENOSYS;
		return -1;
		break;

	case TIOCHPCL:
	case TIOCEXCL:
	case TIOCNXCL:
	case TIOCFLUSH:
	case TIOCSTOP:
	case TIOCSTART:
	case TIOCNOTTY:
	case TIOCSBRK:
	case TIOCCBRK:
	case TIOCSDTR:
	case TIOCCDTR:
	case TIOCDRAIN:
		break;


	case TIOCSTI:
		{
			char *argp;
			argp = va_arg(ap, char *);
			_clist_push( _libc_tty_ptr->t_rawq , *argp );
		}
		break;


	case TIOCGETA:
		{
			struct termios *argp;
			argp = va_arg(ap, struct termios *);

			*argp = _libc_tty_ptr->t_termios;
		}
		break;

	case TIOCSETAW:
	case TIOCSETAF:
	case TIOCSETA:
		{
			struct termios *argp;
			argp = va_arg(ap, struct termios *);

			_libc_tty_ptr->t_termios = *argp;
		}
		break;



	case TIOCGETD:
	case OTIOCGETD:
		{
			int *argp;
			argp = va_arg(ap, int *);

			/* CfBVv̓T|[gĂȂ̂ŁA
			Ƃ肠_~[̒lԂ */
			*argp = _libc_ttywork_ptr->disc;
		}
		break;

	case TIOCSETD:
	case OTIOCSETD:
		{
			int *argp;
			argp = va_arg(ap, int *);

			/* CfBVv̓T|[gĂȂ̂ŁA
			Ƃ肠_~[̒lZbg */
			_libc_ttywork_ptr->disc = *argp;
		}
		break;






	case TIOCGETP:
		{
			struct sgttyb *argp;
			tcflag_t	lflag,iflag,oflag,cflag;
			int	rc;

			argp = va_arg(ap, struct sgttyb *);

			lflag = _libc_tty_ptr->t_lflag;
			cflag = _libc_tty_ptr->t_cflag;
			iflag = _libc_tty_ptr->t_iflag;
			oflag = _libc_tty_ptr->t_oflag;

			argp->sg_ispeed = _libc_tty_ptr->t_ispeed;
			argp->sg_ospeed = _libc_tty_ptr->t_ospeed;
			argp->sg_erase  = _libc_tty_ptr->t_cc[VERASE];
			argp->sg_kill   = _libc_tty_ptr->t_cc[VKILL];

			argp->sg_flags &= ~(CRMOD|ECHO|LCASE|CBREAK|ODDP|EVENP|RAW);

			argp->sg_flags = (
							(((iflag & ICRNL) && (oflag & ONLCR)) ? CRMOD : 0 ) |
							((lflag & ECHO  ) ? ECHO   : 0 ) |
							((lflag & XCASE ) ? LCASE  : 0 ) |
							((iflag & IUCLC ) ? LCASE  : 0 ) |
							((oflag & OLCUC ) ? LCASE  : 0 ) |
							((lflag & ICANON ) ? 0 : CBREAK )
							);

#if 0
			if( cflag & PARENB ){
				argp->sg_flags |= PARODD ? ODDP : EVENP;
			}else{
				argp->sg_flags &= ~PARODD;
			}
#endif

			if( (rc = _dos_ioctrlgt(fd)) < 0 ){
				errno = _errcnv(rc);
				return -1;
			}else if( rc & _DEV_RAW ){
				argp->sg_flags |= RAW;
			}else{
				argp->sg_flags &= ~RAW;
			}
		}
		break;

	case TIOCSETP:
	case TIOCSETN:
		{
			struct sgttyb *argp;
			short flag;

			argp = va_arg(ap, struct sgttyb *);

			_libc_tty_ptr->t_ispeed = argp->sg_ispeed;
			_libc_tty_ptr->t_ospeed = argp->sg_ospeed;
			_libc_tty_ptr->t_cc[VERASE] = argp->sg_erase;
			_libc_tty_ptr->t_cc[VKILL]  = argp->sg_kill;

			_libc_tty_ptr->t_iflag &= ~(ICRNL|IUCLC);
			_libc_tty_ptr->t_oflag &= ~(ONLCR|OLCUC);
			_libc_tty_ptr->t_lflag &= ~(ECHO|ICANON|XCASE);
			_libc_tty_ptr->t_cflag &= ~(PARENB|PARODD);


			flag = argp->sg_flags;

			_libc_tty_ptr->t_iflag |= ((flag & CRMOD)  ? ICRNL  : 0 ) |
									 ((flag & LCASE)  ? IUCLC  : 0 );

			_libc_tty_ptr->t_oflag |= ((flag & CRMOD)  ? ONLCR  : 0 ) |
									 ((flag & LCASE)  ? OLCUC  : 0 );

			_libc_tty_ptr->t_lflag |= ((flag & ECHO)   ? ECHO   : 0) |
									 ((flag & CBREAK) ? 0 : ICANON) |
									 ((flag & LCASE)  ? XCASE : 0 );

#if 0
			_libc_tty_ptr->t_cflag |= (flag & ODDP|EVENP ) ? PARENB : 0;
			_libc_tty_ptr->t_cflag |= (flag & ODDP ) ? PARODD : 0;
#endif

			{
				int md,rc;
				if( flag & RAW ){
					md = 0x20;
				}else{
					md = 0x00;
				}

				if( (rc = _dos_ioctrlst(fd, md)) < 0 ){
					errno = _errcnv(rc);
					return -1;
				}
			}
		}
		break;


	case TIOCGETC:
		{
			struct tchars *argp;
			argp = va_arg(ap, struct tchars *);

			argp->t_intrc  = _libc_tty_ptr->t_cc[VINTR];
			argp->t_quitc  = _libc_tty_ptr->t_cc[VQUIT];
			argp->t_startc = _libc_tty_ptr->t_cc[VSTART];
			argp->t_stopc  = _libc_tty_ptr->t_cc[VSTOP];
			argp->t_eofc   = _libc_tty_ptr->t_cc[VEOF];
			argp->t_brkc   = _libc_tty_ptr->t_cc[VEOL];
		}
		break;

	case TIOCSETC:
		{
			struct tchars *argp;
			argp = va_arg(ap, struct tchars *);

			_libc_tty_ptr->t_cc[VINTR]  = argp->t_intrc;
			_libc_tty_ptr->t_cc[VQUIT]  = argp->t_quitc;
			_libc_tty_ptr->t_cc[VSTART] = argp->t_startc;
			_libc_tty_ptr->t_cc[VSTOP]  = argp->t_stopc;
			_libc_tty_ptr->t_cc[VEOF]   = argp->t_eofc;
			_libc_tty_ptr->t_cc[VEOL]   = argp->t_brkc;
			break;
		}
		break;


	case TIOCLGET:
		{
			int *argp;
			int lword;
			tcflag_t lflag,iflag,oflag,cflag;

			argp = va_arg(ap, int *);

			lflag = _libc_tty_ptr->t_lflag;
			cflag = _libc_tty_ptr->t_cflag;
			iflag = _libc_tty_ptr->t_iflag;
			oflag = _libc_tty_ptr->t_oflag;

			lword = 	((lflag & ECHOE)   ? LCRTBS|LCRTERA : 0 ) |
						((lflag & ECHOPRT) ? LPRTERA : 0 ) |
						((oflag & OPOST)   ? 0 : LLITOUT ) |
						((lflag & TOSTOP)  ? LTOSTOP : 0 ) |
						((lflag & FLUSHO)  ? LFLUSHO : 0 ) |
						((cflag & HUPCL)   ? LNOHANG : 0 ) |
						((lflag & ECHOKE)  ? LCRTKIL : 0 ) |
						(((cflag & CSIZE)==CS8) ? LPASS8 : 0 ) |
						((lflag & ECHOCTL) ? LCTLECH : 0 ) |
						((iflag & IXANY)   ? 0 : LDECCTQ ) |
						((lflag & NOFLSH)  ? LNOFLSH : 0 );

			*argp = lword;
		}
		break;

	case TIOCLSET:
		{
			int *argp;
			int lword;
			tcflag_t lflag,iflag,oflag,cflag;

			argp = va_arg(ap, int *);

			lflag = _libc_tty_ptr->t_lflag;
			cflag = _libc_tty_ptr->t_cflag;
			oflag = _libc_tty_ptr->t_oflag;
			iflag = _libc_tty_ptr->t_iflag;

			lword = *argp;

			lflag &= ~(ECHOE|ECHOPRT|TOSTOP|FLUSHO|ECHOKE|ECHOCTL|NOFLSH);
			oflag &= ~(OPOST);
			cflag &= ~(HUPCL|CSIZE);
			iflag &= ~(IXANY);

			lflag |=	((lword & (LCRTBS|LCRTERA)) ? ECHOE : 0) |
						((lword & LPRTERA) ? ECHOPRT : 0 ) |
						((lword & LTOSTOP) ? TOSTOP : 0 ) |
						((lword & LFLUSHO) ? FLUSHO : 0 ) |
						((lword & LCRTKIL) ? ECHOKE : 0 ) |
						((lword & LCTLECH) ? ECHOCTL : 0 ) |
						((lword & LNOFLSH) ? NOFLSH : 0 );

			oflag |=	((lword & LLITOUT) ? 0 : OPOST );

			iflag |=	((lword & LDECCTQ) ? 0 : IXANY );

			cflag |=	((lword & LNOHANG) ? HUPCL : 0 ) |
						((lword & LPASS8)  ? CS8 : CS7 );

			_libc_tty_ptr->t_lflag = lflag;
			_libc_tty_ptr->t_cflag = cflag;
			_libc_tty_ptr->t_oflag = oflag;
			_libc_tty_ptr->t_iflag = iflag;

		}
		break;


	case TIOCLBIS:
		{
			int *argp;
			int lword;

			argp = va_arg(ap, int *);

			if( ioctl(fd,TIOCLGET,&lword) < 0 )
				return -1;

			lword |= *argp;

			if( ioctl(fd,TIOCLSET,&lword) < 0 )
				return -1;

		}
		break;


	case TIOCLBIC:
		{
			int *argp;
			int lword;

			argp = va_arg(ap, int *);

			if( ioctl(fd,TIOCLGET,&lword) < 0 )
				return -1;

			lword &= ~*argp;

			if( ioctl(fd,TIOCLSET,&lword) < 0 )
				return -1;

		}
		break;





	case TIOCSLTC:
		{
			struct ltchars *argp;

			argp = va_arg(ap, struct ltchars *);

			_libc_tty_ptr->t_cc[VSUSP]    = argp->t_suspc;
			_libc_tty_ptr->t_cc[VDSUSP]   = argp->t_dsuspc;
			_libc_tty_ptr->t_cc[VREPRINT] = argp->t_rprntc;
			_libc_tty_ptr->t_cc[VDISCARD] = argp->t_flushc;
			_libc_tty_ptr->t_cc[VWERASE]  = argp->t_werasc;
			_libc_tty_ptr->t_cc[VLNEXT]   = argp->t_lnextc;

		}
		break;

	case TIOCGLTC:
		{
			struct ltchars *argp;

			argp = va_arg(ap, struct ltchars *);

			argp->t_suspc  = _libc_tty_ptr->t_cc[VSUSP];
			argp->t_dsuspc = _libc_tty_ptr->t_cc[VDSUSP];
			argp->t_rprntc = _libc_tty_ptr->t_cc[VREPRINT];
			argp->t_flushc = _libc_tty_ptr->t_cc[VDISCARD];
			argp->t_werasc = _libc_tty_ptr->t_cc[VWERASE];
			argp->t_lnextc = _libc_tty_ptr->t_cc[VLNEXT];

		}
		break;


	case TIOCGWINSZ:
		{
			struct winsize *argp;
			int x,y,tmp;

			argp = va_arg(ap, struct winsize *);

			tmp = _iocs_b_consol(-1,-1,-1,-1);
			y = (tmp & 0xffff);
			x = (tmp / 65536);
			argp->ws_row    = y+1;
			argp->ws_col    = x+1;
			argp->ws_xpixel = 0;
			argp->ws_ypixel = 0;
		}
		break;

	case TIOCSWINSZ:
		{
			struct winsize *argp;
			int x,y;

			argp = va_arg(ap, struct winsize *);

			y = (argp->ws_row - 1) & 0xffff;
			x = (argp->ws_col - 1) & 0xffff;
			_iocs_b_consol(0,0,x,y);
		}
		break;

	default:
		errno = EINVAL;
		return -1;
		break;
	}


	va_end(ap);

	return 0;
}

