#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/dos.h>
#include <sys/xstdio.h>
#include <sys/xglob.h>
#include <sys/xunistd.h>
#include <iocslib.h>

int read (int fileno, char *buffer, unsigned int bytes)
{
	int n, rc;
	int count;
	long position;
	char ch, got;
	char *rp, *wp;

#ifdef EBADF_CHECKER
	/* sȃt@Cnh`FbN */
	if (_usedfd (fileno) < 0) {
		errno = EBADF;
		return -1;
	}
#endif

	/* 0 oCgȂ牽sȂ */
	if (bytes <= 0)
		return 0;

	/* L[{[h̓ǂݍ... */
	if( isatty(fileno) ){

		_flushtty();		/* tty ̂݃obt@tbV */

		/* cooked/raw ̊mF */
		if( (rc = _dos_ioctrlgt (fileno)) < 0 ){
			errno = _errcnv(rc);
			return -1;
		}

		/* raw foCX */
		else if( rc & _DEV_RAW )
			return _raw_readtty(fileno, buffer, bytes);

		/* cooked foCX */
		else
			return _cooked_readtty(fileno, buffer, bytes);
	}

	/* oCi[h̏ */
	if (_fddb[fileno].oflag & O_BINARY) {

		/* oCi[hł͂ǂނ */
		if ((count = _dos_read (fileno, buffer, bytes)) < 0) {
			errno = _errcnv (count);
			return -1;
		}

	}
	else {

		/* EOF Ȃ炱ɂďI */
		if (_fddb[fileno].oflag & O_TXTEOF)
			return 0;

		/* ǂ߂邾ǂ */
		if ((rc = _dos_read (fileno, buffer, bytes)) < 0) {
			errno = _errcnv (rc);
			return -1;
		}

		/* ϊp̕ϐ */
		n = rc;
		wp = rp = buffer;
		count = 0;

		/* CR/LF -> LF ϊ */
		while (n--) {

			/* EOF(^Z) ɂł... */
			if ((ch = *rp++) == 0x1a) {

				/* TEXTEOF tOݒ */
				_fddb[fileno].oflag |= O_TXTEOF;
				break;

			}

			/* CR ɂł... */
			if (ch == '\r') {

				/* obt@ɗ]f[^邩? */
				if (n) {

					/*  LF ł CR 𔲂 */
					if (*rp == '\n') {
						ch = *rp++;
						n--;
					}

				}

				/* ]肪Ȃ΂ 1 oCgǂݏoĒׂ */
				else {

					/* ܂݈ʒuL */
					position = _dos_seek (fileno, 0, 1);

					/* 1 oCgǂ݂ */
					if ((rc = _dos_read (fileno, &got, 1)) < 0) {
						errno = _errcnv (rc);
						return -1;
					}

					/*  LF Ȃ CR 𔲂 */
					if (got == '\n')
						ch = got;

					/* LF Ȃ΃t@C|C^߂ */
					else
						_dos_seek (fileno, position, 0);

				}

			}

			/* f[^] */
			*wp++ = ch;

		}

		/* oCg߂ */
		count = wp - buffer;

	}

	/* ߂ */
	return count;
}
