#include <sys/dos.h>
#include <sys/iocs.h>

#include <unistd.h>
#include <fcntl.h>

#include "readtty.h"

#define	LINEBUF_SIZE	1024
struct editline {
	int				curcol;
	char			flag[LINEBUF_SIZE];
	unsigned char	buf[LINEBUF_SIZE];
};
static struct editline _libc_editline;


struct	tty			*_libc_tty_ptr      = &_libc_tty;
struct	_ttywork	*_libc_ttywork_ptr  = &_libc_ttywork;


static int nowfd;

extern unsigned char __xcase_type[128];

char _character_code_flag[256] = {
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,
	3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
	2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
	2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,
	3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3
};

static void echoctl( unsigned char );
static void ifechoctl( unsigned char );
static void	ins_chr( unsigned char );
static void	erase_chr( void );
static void	kill_chr( void );
static void	werase_chr( void );
static void	reprint_chr( void );
static void	echo_chr( unsigned char );
static void	console_to_queue( void );

extern int	_clist_sense( struct clist * );
extern int	_clist_flush( struct clist * );
extern int	_clist_push( struct clist *, char );
extern int	_clist_pop( struct clist * );
extern int	_clist_shift( struct clist * );
extern int	_clist_unshift( struct clist *, char );


static void echoctl( unsigned char c )
{
	c ^= 0x40;
	_dos_c_putc('^');
	_dos_c_putc(c);
}

static void ifechoctl( unsigned char c )
{
	if( _libc_tty_ptr->t_lflag & ECHOCTL ){
		echoctl(c);
	}
}



static void ins_chr( unsigned char c )
{
	int	col;

	col = _libc_editline.curcol;

	if( LINEBUF_SIZE <= col ){
		if( _libc_tty_ptr->t_iflag & IMAXBEL )
			_dos_c_putc(0x07);				/* ꂽ BEL */
		return;
	}

	_libc_editline.buf[col] = c;

	if( (0<col) && (_libc_editline.flag[col-1] >= 2) ){
		_libc_editline.flag[col] = -_libc_editline.flag[col-1];	/* 2byteR[h2byteڂ- */
		if ( _libc_tty_ptr->t_lflag & ECHO ){					/* ͏o͏͍lȂ */
			_dos_c_putc( _libc_editline.buf[col-1] );
			_dos_c_putc( c );
		}
	}else{
		if( (_libc_editline.flag[col] = _character_code_flag[c]) < 2 ){
			echo_chr(c);
		}else{
			_libc_tty_ptr->t_rawcc |= TS_LNCH;					/* 2byteڂ͏Ȃ */
		}
	}

	_libc_editline.curcol = ++col;
}



static __inline void erase1()
{
	if( _libc_tty_ptr->t_lflag & ECHO ){
		_dos_c_putc(0x08);
		if ( _libc_tty_ptr->t_lflag & ECHOE ){
			_dos_c_putc(0x20);
			_dos_c_putc(0x08);
		}
	}
}

static __inline void erase2()
{
	if( _libc_tty_ptr->t_lflag & ECHO ){
		_dos_c_print("\b\b");
		if ( _libc_tty_ptr->t_lflag & ECHOE )
			_dos_c_print("  \b\b");
	}
}



static void erase_chr()
{
	int col;
	col = _libc_editline.curcol;

	if( !col )
		return;

	switch( _libc_editline.flag[col-1] ){
	case -3:
		col-=2;
		erase1();
		break;

	case -2:
		col-=2;
		erase2();
		break;

	case 0:
		col--;
		if( _libc_tty_ptr->t_lflag & ECHOCTL )
			erase2();
		else
			erase1();

		break;

	case 1:
		col--;
		erase1();
		break;

	case 2:
	case 3:
		col--;
		break;

	default:
		break;
	}

	_libc_editline.curcol = col;
}



static void kill_chr()
{
	if( _libc_tty_ptr->t_lflag & ECHOKE ){
		while( _libc_editline.curcol )
			erase_chr();
	}else{
		_libc_editline.curcol = 0;
	}

	if( _libc_tty_ptr->t_lflag & ECHOK ){
		echo_chr('\n');
	}
}

static void werase_chr()
{
	while(1){
		if( !_libc_editline.curcol )		return;
		if( _libc_editline.flag[_libc_editline.curcol-1] != 1 )	break;
		if( _libc_editline.buf[_libc_editline.curcol-1]  != ' ' )	break;
		erase_chr();
	}

	while(1){
		if( !_libc_editline.curcol )		return;
		if( _libc_editline.flag[_libc_editline.curcol-1] == 1   &&
		    _libc_editline.buf[_libc_editline.curcol-1]  == ' '
		  )
		    break;

		erase_chr();
	}

}





static void reprint_chr()
{

	echo_chr( _libc_tty_ptr->t_cc[VREPRINT] );
	echo_chr( '\n' );

	{
		int col=0;
		while( col < _libc_editline.curcol ){
			if( _libc_editline.flag[col] >= 2 ){
				if ( _libc_tty_ptr->t_lflag & ECHO ){			/* ͏o͏͍lȂ */
					_dos_c_putc( _libc_editline.buf[col++] );
					_dos_c_putc( _libc_editline.buf[col++] );
				}
			}else{
				echo_chr( _libc_editline.buf[col++] );
			}
		}
	}
}

static void echo_chr(unsigned char c)
{
	if( _libc_tty_ptr->t_lflag & ECHO ){

		if( (_libc_tty_ptr->t_rawcc & TS_LNCH) && (c < 0x20) )
			goto echo_ctl;

		if( _libc_tty_ptr->t_oflag & OPOST ){
			if      ( c == '\n' && (_libc_tty_ptr->t_oflag & ONLCR) ){
				_dos_c_print("\r\n");
				return;
#ifdef OCRNL
			}else if( c == '\r' && (_libc_tty_ptr->t_oflag & OCRNL) ){
				_dos_c_putc('\n');
				return;
#endif

#ifdef ONOEOT
			}else if( c == _libc_tty_ptr->t_cc[VEOF] && (_libc_tty_ptr->t_oflag & ONOEOT) ){
				return;
#endif
			}
		}

		if( (c<' '||c==0x7f) && (_libc_tty_ptr->t_lflag & ECHOCTL) &&
		    (c != '\n')
		  ){
echo_ctl:
			echoctl( c );
			return;
		}

		if( 'A' <= c && c <= 'Z' ){
			if( _libc_tty_ptr->t_lflag & XCASE ){
				_dos_c_putc( '\\' );
				_dos_c_putc( c );
				return;
			}
		}

#ifdef OLCUC
		if( 'a' <= c && c <= 'z' ){
			if( _libc_tty_ptr->t_oflag & OLCUC ){
				_dos_c_putc( c - 'a' + 'A' );
				return;
			}
		}
#endif
		_dos_c_putc(c);

	}else if( c == '\n' && (_libc_tty_ptr->t_lflag & ECHONL) )
		_dos_c_putc(c);
}



static void console_to_queue()
{
	unsigned char ch;

	while(1){
		if( !_dos_k_keysns() ){
			if( _libc_tty_ptr->t_lflag & ICANON ){
				continue;
			}else{
				return;
			}
		}

		ch = _dos_k_keyinp();

		/* CTRL + SPACE Ȃ 0x00 Ԃ悤ɍ׍H */
		if( ch == ' ' && (_dos_k_sftsns() & 2) && (_dos_k_keybit(6) & 0x20) )
			ch = '\0';

		/* cooked[h */

		if( (_libc_tty_ptr->t_rawcc & TS_LNCH) ){
			goto iproc_skip;
		}


		/* ͏ */

		if( ch == 0xff )	/* ch  -1 Ȃ珈s\(c_cc̖flagɂȂ邩) */
			goto iproc_skip;


		if( _libc_tty_ptr->t_lflag & ISIG ){

			if( !(_libc_tty_ptr->t_iflag & IGNBRK) &&
				(ch == _libc_tty_ptr->t_cc[VINTR]) ){
				if( _libc_tty_ptr->t_iflag & BRKINT ){
					ifechoctl(ch);
#ifdef SIGINT
					kill( getpid(), SIGINT );
#else
					_dos_c_print("\r\n");
					_dos_ctlabort ();
#endif
				}else{
					ch = '\0';
					goto iproc_skip;
				}
			}

			if(ch == _libc_tty_ptr->t_cc[VQUIT]){
				ifechoctl(ch);
#ifdef SIGQUIT
				kill( getpid(), SIGQUIT );
#else
				_dos_c_print("\r\n");
				_dos_ctlabort ();
#endif
				continue;
			}

#ifdef SIGTSTP
			if(ch == _libc_tty_ptr->t_cc[VSUSP]){
				ifechoctl(ch);
				kill( getpid(), SIGTSTP );
				continue;
			}

			/* { read 鎞ǂǁ[ĂȂǁ[ł */
			if(ch == _libc_tty_ptr->t_cc[VDSUSP]){
				ifechoctl(ch);
				kill( getpid(), SIGTSTP );
				continue;
			}
#else

#	ifdef SUSPEND
/* SIGTSTP΂悩̂... :-P */
			if(ch == _libc_tty_ptr->t_cc[VSUSP]){
				int sv0,sv1,sv2,sv3,sv4;


				sv0 = dup(0);
				sv1 = dup(1);
				sv2 = dup(2);
				sv3 = dup(3);
				sv4 = dup(4);

				close(0);
				close(1);
				close(2);
				close(3);
				close(4);

				ifechoctl(ch);
				_dos_c_print("\r\nSuspended\r\n");
				system((char *)0);

				dup2(sv0,0);
				dup2(sv1,1);
				dup2(sv2,2);
				dup2(sv3,3);
				dup2(sv4,4);

				close(sv0);
				close(sv1);
				close(sv2);
				close(sv3);
				close(sv4);

				continue;
			}
#	endif
#endif
		}

		if( ((ch == _libc_tty_ptr->t_cc[VSTART])||
		     (ch == _libc_tty_ptr->t_cc[VSTOP])   ) &&
		    (_libc_tty_ptr->t_iflag & IXOFF)            )
			continue;

		if( ( ch == _libc_tty_ptr->t_cc[VLNEXT]) &&
		    (_libc_tty_ptr->t_lflag & IEXTEN)        ){

			_libc_tty_ptr->t_rawcc |= TS_LNCH;
			continue;
		 }

		if( ch == '\r'){
			if(_libc_tty_ptr->t_iflag & IGNCR)
				continue;
			if(_libc_tty_ptr->t_iflag & ICRNL)
				ch = '\n';
		}else if( (ch == '\n') && (_libc_tty_ptr->t_iflag & INLCR) )
			ch = '\r';

#ifdef IUCLC
		else if( (('A' <= ch) && (ch <= 'Z')) && (_libc_tty_ptr->t_iflag & IUCLC) ){
			ch += ('a'-'A');
		}
#endif

		if( _libc_tty_ptr->t_iflag & ISTRIP ){
			ch &= 0x7f;
		}

iproc_skip:


		if( _libc_tty_ptr->t_lflag & ICANON ){
			/* cooked[h */

			if(_libc_tty_ptr->t_rawcc & TS_LNCH){
				ins_chr( ch );
				_libc_tty_ptr->t_rawcc &= ~TS_LNCH;
			}else{
				if      ( ch == _libc_tty_ptr->t_cc[VERASE] ){
					erase_chr();

				}else if( ch == _libc_tty_ptr->t_cc[VKILL] ){
					kill_chr();

				}else if( ch == _libc_tty_ptr->t_cc[VWERASE] ){
					werase_chr();

				}else if( ch == _libc_tty_ptr->t_cc[VREPRINT] ){
					reprint_chr();

				}else if( ch == _libc_tty_ptr->t_cc[VEOF] ){
					int i = _libc_editline.curcol;
					unsigned char *p = _libc_editline.buf;
					_libc_editline.curcol = 0;
					while( i-- )
						_clist_push( &_libc_tty_ptr->t_rawq, *p++ );

					echo_chr(ch);

					return;

				}else if(
							(ch == '\n') ||
							(_libc_tty_ptr->t_cc[VEOL] == ch) ||
							(
							 (_libc_tty_ptr->t_cc[VEOL2] == ch) &&
							 (_libc_tty_ptr->t_lflag & IEXTEN)
							)
						){

					int i = _libc_editline.curcol;
					unsigned char *p = _libc_editline.buf;
					_libc_editline.curcol = 0;
					while( i-- )
						_clist_push( &_libc_tty_ptr->t_rawq, *p++ );

					echo_chr(ch);
					_clist_push( &_libc_tty_ptr->t_rawq, ch );
					return;

				}else{
					ins_chr( ch );
				}
			}

		}else{
			/* cbreak[h */

			echo_chr(ch);
			_libc_tty_ptr->t_rawcc &= ~TS_LNCH;

			_clist_push( &_libc_tty_ptr->t_rawq, ch );
		}
	}
}


int	_cooked_readtty( fd, buffer, bytes )
int fd;
unsigned char *buffer;
int bytes;
{
	int n = bytes;
	unsigned char *p = buffer;

	nowfd = fd;


	if( _libc_tty_ptr->t_lflag & ICANON ){
		unsigned char c;

		if( !_clist_sense(&_libc_tty_ptr->t_rawq) )
			console_to_queue();

		while( n ){
			if( !_clist_sense(&_libc_tty_ptr->t_rawq) )
				break;
			c = _clist_shift( &_libc_tty_ptr->t_rawq );
			if( _libc_tty_ptr->t_lflag & XCASE ){
				if( c == '\\' ){
					if( !_clist_sense(&_libc_tty_ptr->t_rawq) )
						break;
					c = _clist_shift( &_libc_tty_ptr->t_rawq );

					switch( __xcase_type[c]){
					case 0:
					case 2:
						break;
					case 1:
						c = c - 'a' + 'A';
						break;
					default:
						c = __xcase_type[c];
						break;
					}
				}
			}

			*p++ = c;
			n--;
		}

	}else{

/* cbreak Ȃ͂ꍇblockȂ΂ȂȂ */
		while(!_clist_sense(&_libc_tty_ptr->t_rawq) ){
			_dos_change_pr();
			console_to_queue();			/* queueɎ荞 */
		}

		while( n ){
			*p++ = _clist_shift( &_libc_tty_ptr->t_rawq );
			n--;

			console_to_queue();			/* queueɎ荞 */
			if( !_clist_sense(&_libc_tty_ptr->t_rawq) )
				break;
		}
	}

	return( bytes - n );
}





int	_raw_readtty( fd, buffer, bytes )
int fd;
unsigned char *buffer;
int bytes;
{
	int n = bytes;
	unsigned char *p = buffer;


/* ͂ꍇblock */
	while( !_dos_k_keysns() )
		_dos_change_pr();

	while( n ){
		unsigned char ch;

		if( _dos_k_keysns() == 0 )
			break;

		ch = _dos_k_keyinp();

		/* CTRL + SPACE Ȃ 0x00 Ԃ悤ɍ׍H */
		if( ch == ' ' && (_dos_k_sftsns() & 2) && (_dos_k_keybit(6) & 0x20) )
			ch = '\0';

		*p++ = ch;
		echo_chr(ch);

		n--;
	}


	return( bytes - n );
}

